<template>
  <div style="wight:100%;height:100%;">
    <div :id="`mars3d-container${mapKey}`"
    :class="['mars3d-container', customClass, { 'mars3d-container-compare-rh' : compare }]"></div>

    <!-- <div class="infoview">
      <el-button type="primary" @click="btnStartDraw()">设置围栏</el-button>
      <el-button type="primary" @click="uploaded()">上传围栏</el-button>
      <div style="display: inline-block;color:red;font-weight:bolder;">每次只允许上传一个围栏，并且围栏必须是封闭图形</div>
    </div> -->

  </div>

</template>

<script>
import Vue from 'vue'
import { Tools, HttpReq, CAMap} from '@/assets/js/common.js';

// 使用免费开源版本
import 'mars3d/dist/mars3d.css'
import * as mars3d from 'mars3d'
import * as Cesium from 'mars3d-cesium/Build/Cesium/Cesium'
import  { initGraphicManager,initLayerManager,bindLayerContextMenu } from './js/graphicManager'


// 导入插件(其他插件类似，插件清单访问：http://mars3d.cn/dev/guide/start/install.html)
// echarts插件
// import 'mars3d-echarts'

// 为了方便使用,绑定到原型链，在其他vue文件，直接 this.mars3d 来使用
Vue.prototype.mars3d = mars3d
Vue.prototype.Cesium = mars3d.Cesium

var map;
export default {
  name: 'mars3dViewer',

  created(){
    this.getCoordinate();
  },

  data(){
    return{
      historyTrajectoryData:[],
      persons:[
          ["122.128833", "37.526448", "500"],
          ["122.128638", "37.522818", "500"],
          ["122.128738", "37.522818", "500"],
          ["122.128638", "37.528518", "500"],
          ["122.128538", "37.528818", "500"],
          ["122.128538", "37.525818", "500"],
          ["122.121538", "37.523318", "500"],
          ["122.127833", "37.525448", "500"],
          
          ["122.128833", "37.526448", "500"],
          ["122.128638", "37.522818", "500"],
          ["122.128738", "37.522818", "500"],
          ["122.128638", "37.528518", "500"],
          ["122.128538", "37.528818", "500"],
          ["122.128538", "37.525818", "500"],
          ["122.121538", "37.523318", "500"],
          ["122.127833", "37.525448", "500"],
   
          ["122.128833", "37.526448", "500"],
          ["122.128638", "37.522818", "500"],
          ["122.128738", "37.522818", "500"],
          ["122.128638", "37.528518", "500"],
          ["122.128538", "37.528818", "500"],
          ["122.128538", "37.525818", "500"],
          ["122.121538", "37.523318", "500"],
          ["122.127833", "37.525448", "500"],

          ["122.128833", "37.526448", "500"],
          ["122.128638", "37.522818", "500"],
          ["122.128738", "37.522818", "500"],
          ["122.128638", "37.528518", "500"],
          ["122.128538", "37.528818", "500"],
          ["122.128538", "37.525818", "500"],
          ["122.121538", "37.523318", "500"],
          ["122.127833", "37.525448", "500"],

          ["122.128833", "37.526448", "500"],
          ["122.128638", "37.522818", "500"],
          ["122.128738", "37.522818", "500"],
          ["122.128638", "37.528518", "500"],
          ["122.128538", "37.528818", "500"],
          ["122.128538", "37.525818", "500"],
          ["122.121538", "37.523318", "500"],
          ["122.127833", "37.525448", "500"],

      ],
      deviceId:'DESKTOP-L56LKGM',
      zuobianData:[],
      toJavaCoordinates:[],
      weilanName:[],
    }
  },

  props: {
    // 初始化配置参数
    url: String,

    // 地图唯一性标识
    mapKey: {
      type: String,
      default: ''
    },

    // 自定义参数
    options: Object,

    // 是否分屏显示
    compare: {
      type: Boolean,
      default: false
    },

    // 是否插入到body元素上
    appendToBody: {
      type: Boolean,
      default: false
    },

    // 自定义css类名
    customClass: {
      type: String,
      default: ''
    }
  },

  destroy() {
    this[`map${this.mapKey}`].destroy()
    delete this[`map${this.mapKey}`]
  },

  methods: {
    //后台获取数据——获取电子围栏
    getCoordinate() {
      let that = this;
      HttpReq.truckDispatching.screenMapSetUpQuery({size:9999}).then((res) => {
				if(true){;
					//console.log(res);
          let data1 = [];
          for(let key  in res){
            that.weilanName.push(key);
            let arrays = [];
            res[key].forEach(function(item){
              var arr = [];
              arr[0] = item.lon;
              arr[1] = item.lat;
              arr[2] = "500";
              arrays.push(arr);
            })
            data1.push(arrays)
          }
          that.zuobianData = data1
          //console.log("zuobianData",that.zuobianData);
          //console.log("weilanName",that.weilanName); 

          //后台获取数据——获取历史轨迹
          this.getlishiguijiFn();

				}
			})

    },
    //后台获取数据——获取历史轨迹
    getlishiguijiFn() {
      let that = this;
      HttpReq.truckDispatching.getAllHistroyCarTrajectoryQuery({name:that.deviceId}).then((res) => {
				//console.log('获取历史轨迹',res);
        if(res.code == 200){
          let obj1 = {};
          let array1 = [];
          res.data.line.forEach((item,index)=>{
            let array2 = [];
            array2.push(item.location.x);
            array2.push(item.location.y);
            array2.push('500');
            array1.push(array2);
          })
          obj1.name = res.data.name;
          obj1.arrays = array1;
          let hisCenterData = [...that.historyTrajectoryData];
          hisCenterData.push(obj1);
          that.historyTrajectoryData = [...hisCenterData];
          
          this.$nextTick(()=>{
            if (this.appendToBody) {
              document.body.appendChild(this.$el)
            }
            if (this.mapKey) {
              this.initMars3d(this.options)
            } else {
              mars3d.Resource.fetchJson({ url: this.url }).then((data) => {
                this.initMars3d(data.map3d)// 构建地图
              })
            }
          })
        }
			})

    },
    //上传围栏数据
    uploaded(){
      let newData = [...this.toJavaCoordinates];
      newData.pop();
      if(this.toJavaCoordinates.length == 0){
        this.$message({
          type: 'warning',
          message: '请绘制电子围栏'
        }); 
      }else{
        this.$prompt('电子围栏名称不得为空且不能与之前围栏名称重复', '请输入电子围栏名称', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          inputErrorMessage: '输入不能为空',
          inputValidator: (value) => {  // 点击按钮时，对文本框里面的值进行验证
            if(!value) {
                return '输入不能为空';
            }
          },
        }).then(({ value }) => {
          let allObj = {};
          allObj.name = value;
          allObj.zuobiao = newData;
          this.toJavaCoordinates = [];
          console.log(allObj);
          //发送添加电子围栏请求
          HttpReq.truckDispatching.screenMapSetUpAdd(allObj).then((res) => {
            if(res.code == 200){
              this.$notify({
                title: '上传电子围栏成功！',
                type: 'success',
                duration: 2500
              });
            }else{
              this.$notify({
                title: res.msg,
                type: 'error',
                duration: 2500
              })
            }
          }).catch(function(error) { });
        }).catch(() => {
          this.$message({
            type: 'info',
            message: '取消输入'
          });       
        });
      }

    },
    //创建地图
    initMars3d(options) {
      let that = this;
      if (this[`map${this.mapKey}`]) return

      const mapOptions = {
        ...options,
        ...this.options,
        control: {
          defaultContextMenu: false, //右键菜单
        },
      }

      // 创建三维地球场景
      map = new mars3d.Map(`mars3d-container${this.mapKey}`, mapOptions)
      this[`map${this.mapKey}`] = map
      
      //围栏回显
      that.zuobianData.forEach(function(item,index){
        console.log(item);
        var graphicLayer = new mars3d.layer.GraphicLayer();
        map.addLayer(graphicLayer);
        initLayerManager(graphicLayer,that.weilanName[index]);
        that.addGraphic_01(graphicLayer,item,that.weilanName[index]);
      })
      
      //历史轨迹回放
      // that.historyTrajectoryData.forEach(function(item,index){
      //   var graphicLayer2 = new mars3d.layer.GraphicLayer();
      //   map.addLayer(graphicLayer2);
      //   var itemText = `<table style="width: auto;">
      //           <tr>
      //             <th scope="col" colspan="2" style="text-align:center;font-size:15px;">卡车号码：${item.name}</th>
      //           </tr>
      //           <tr>
      //             <td>名称：卡车二</td>
      //           </tr>
      //         </table>`;
      //   initGraphicManager(graphicLayer2,itemText);
      //   that.addGraphic_02(graphicLayer2,item.arrays,item.name);
      // })

      //创建矢量数据图层2
      var graphicLayer1 = new mars3d.layer.GraphicLayer();
      map.addLayer(graphicLayer1);
      var itemText = `<table style="width: auto;">
              <tr>
                <th scope="col" colspan="2" style="text-align:center;font-size:15px;">卡车号码：鲁K12345</th>
              </tr>
              <tr>
                <td>名称：卡车一</td>
              </tr>
            </table>`;
      initGraphicManager(graphicLayer1,itemText);
      that.addGraphic_02(graphicLayer1,this.persons,'卡车一');

      // 抛出事件
      this.$emit('onload', map)
    },
    //围栏设置
    btnStartDraw(){
      this.toJavaCoordinates = [];
      let that = this;
      var graphicLayer3 = new mars3d.layer.GraphicLayer();
      graphicLayer3.on(mars3d.EventType.click, function (event) {
        var mpt = mars3d.LatLngPoint.fromCartesian(event.cartesian);
        that.toJavaCoordinates.push(mpt.toString().split(','));
        console.log(that.toJavaCoordinates);
      });
      map.addLayer(graphicLayer3);
      initLayerManager(graphicLayer3);
      graphicLayer3.startDraw({
            type: "polyline",
            style: {
              color: "red",
              width: 5,
              clampToGround: false,
              label: {
                text: "围栏区域",
                font_size: 18,
                color: "#ffffff",
                distanceDisplayCondition: true,
                distanceDisplayCondition_far: 500000,
                distanceDisplayCondition_near: 0,
              },
            },
          });
    },
    //围栏回显
    addGraphic_01(graphicLayer,positions,weilanName){
      let graphic = new mars3d.graphic.PolygonEntity({
          positions: positions,
          style: {
            color: "red",
            opacity: 0.5,
            outline: true,
            outlineWidth: 3,
            outlineColor: "#ffffff",
            label: {
              text: weilanName,
              font_size: 18,
              color: "#ffffff",
              distanceDisplayCondition: true,
              distanceDisplayCondition_far: 500000,
              distanceDisplayCondition_near: 0,
            },
          },
        });
        graphicLayer.addGraphic(graphic); //还可以另外一种写法: graphic.addTo(graphicLayer)
    },
    //车辆轨迹
    addGraphic_02(graphicLayer1,positions,truckName) {

        var property = new Cesium.SampledPositionProperty();
        var tempTime;
        
        //起点
        tempTime = map.clock.currentTime; //开始时间
        property.addSample(tempTime, Cesium.Cartesian3.fromDegrees(positions[0][0],positions[0][1],positions[0][2]));
        for(let i = 1;i < positions.length;i++){
          tempTime = Cesium.JulianDate.addSeconds(tempTime, 120, new Cesium.JulianDate());
          property.addSample(tempTime, Cesium.Cartesian3.fromDegrees(positions[i][0],positions[i][1],positions[i][2],));
        }

        var graphic = new mars3d.graphic.PathEntity({
          position: property,
          style: {
            width: 3,
            color: "#8a2e3b",
            opacity: 1.0,
            leadTime: 0, // 前方的路线不显示
            //高亮时的样式（默认为鼠标移入，也可以指定type:'click'单击高亮），构造后也可以openHighlight、closeHighlight方法来手动调用
            highlight: {
              type: mars3d.EventType.click,
              color: "#ff0000",
            },
          },
          label: {
            text: truckName,
            font_size: 19,
            font_family: "楷体",
            color: Cesium.Color.AZURE,
            outline: true,
            outlineColor: Cesium.Color.BLACK,
            outlineWidth: 2,
            horizontalOrigin: Cesium.HorizontalOrigin.CENTER,
            verticalOrigin: Cesium.VerticalOrigin.BOTTOM,
            pixelOffset: new Cesium.Cartesian2(10, -25), //偏移量
          },
          model: {
            url: "//data.mars3d.cn/gltf/mars/car/tufangche.glb",
            scale: 0.1,
            minimumPixelSize: 50,
          },
        });
        graphicLayer1.addGraphic(graphic); //还可以另外一种写法: graphic.addTo(graphicLayer)

    },
    getSampledPositionProperty(points){
      let property = new Cesium.SampledPositionProperty();
      let start = this.map.clock.currentTime;
      let positions = mars3d.LatLngArray.toCartesians(points);
      for (let i = 0; i < positions.length; i++) {
        let time = Cesium.JulianDate.addSeconds(start, i * 20, new Cesium.JulianDate());
        let position = positions[i];
        property.addSample(time, position);
      }
      return property;
    },
   
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style >
.cesium-viewer-toolbar{
  
  display: none !important;
}
.mars3d-compass{
  display: none !important;
}
.mars3d-locationbar{
  display: none !important;
}
.mars3d-distance-legend{
  display: none !important;
}
.mars3d-container {
  height: 100%;
  width: 100vw;
  overflow: hidden;
}

/* 重写Cesium的css */

/**cesium按钮背景色*/
.cesium-button {
  background-color: #3f4854;
  color: #e6e6e6;
  fill: #e6e6e6;
  box-shadow: 0 1px 4px rgba(0, 0, 0, 0.3);
  line-height: 32px;
}

.cesium-viewer-geocoderContainer .cesium-geocoder-input {
  background-color: rgba(63, 72, 84, 0.7);
}

.cesium-viewer-geocoderContainer .cesium-geocoder-input:focus {
  background-color: rgba(63, 72, 84, 0.9);
}

.cesium-viewer-geocoderContainer .search-results {
  background-color: #3f4854;
}

.cesium-geocoder-searchButton {
  background-color: #3f4854;
}

.cesium-infoBox-title {
  background-color: #3f4854;
}

.cesium-infoBox {
  background: rgba(63, 72, 84, 0.9);
}

.cesium-toolbar-button img {
  height: 100%;
}

.cesium-performanceDisplay-defaultContainer {
  top: auto;
  bottom: 35px;
  right: 50px;
}
.cesium-performanceDisplay-ms,
.cesium-performanceDisplay-fps {
  color: #fff;
}

/**cesium工具栏位置*/
.cesium-viewer-toolbar {
  top: auto;
  left: auto;
  right: 12px;
  bottom: 35px;
}

.cesium-viewer-toolbar > .cesium-toolbar-button,
.cesium-navigationHelpButton-wrapper,
.cesium-viewer-geocoderContainer {
  margin-bottom: 5px;
  float: right;
  clear: both;
  text-align: center;
}

.cesium-baseLayerPicker-dropDown {
  bottom: 0;
  right: 40px;
  max-height: 700px;
  margin-bottom: 5px;
}

.cesium-navigation-help {
  top: auto;
  bottom: 0;
  right: 40px;
  transform-origin: right bottom;
}

.cesium-sceneModePicker-wrapper {
  width: auto;
}

.cesium-sceneModePicker-wrapper .cesium-sceneModePicker-dropDown-icon {
  float: left;
  margin: 0 3px;
}

.cesium-viewer-geocoderContainer .search-results {
  left: 0;
  right: 40px;
  width: auto;
  position: absolute;
  z-index: 999;
}

.cesium-infoBox-title {
  background-color: #3f4854;
}

.cesium-infoBox {
  top: 50px;
  background: rgba(63, 72, 84, 0.9);
}

/**左下工具栏菜单*/
.toolbar-dropdown-menu-div {
  background: rgba(43, 44, 47, 0.8);
  border: 1px solid #2b2c2f;
  z-index: 999;
  position: absolute;
  right: 60px;
  bottom: 40px;
  display: none;
}

.toolbar-dropdown-menu {
  min-width: 110px;
  padding: 0;
}
.toolbar-dropdown-menu > li {
  padding: 0 3px;
  margin: 2px 0;
}
.toolbar-dropdown-menu > li > a {
  color: #edffff;
  display: block;
  padding: 4px 10px;
  clear: both;
  font-weight: normal;
  line-height: 1.6;
  white-space: nowrap;
  text-decoration: none;
}

.toolbar-dropdown-menu > li > a:hover,
.dropdown-menu > li > a:focus {
  color: #fff;
  background-color: #444d59;
}

.toolbar-dropdown-menu > .active > a,
.dropdown-menu > .active > a:hover,
.dropdown-menu > .active > a:focus {
  color: #fff;
  background-color: #444d59;
}

.toolbar-dropdown-menu i {
  padding-right: 5px;
}

.infoview{
  position: absolute;
  top: 100px;
  left: 500px;
  width: 50vw;
  z-index: 1000;
}
</style>
